package ch.unige.solidify.auth.model;

import java.time.OffsetDateTime;

public class AuthUser implements UserInfo {

  private String resId;
  private String externalUid;
  private OffsetDateTime creationWhen;
  private OffsetDateTime lastUpdateWhen;
  private String creationWho;
  private String lastUpdateWho;
  private Boolean disabled = Boolean.FALSE;
  private String email;
  private String firstName;
  private String homeOrganization;
  private String lastName;
  private AuthApplicationRole applicationRole;
  private AuthLoginInfo firstLogin;
  private AuthLoginInfo lastLogin;

  public AuthUser() {
  }

  public AuthUser(UserInfo userInfo) {
    this.setResId(userInfo.getResId());
    this.setExternalUid(userInfo.getExternalUid());
    this.setEmail(userInfo.getEmail());
    this.setApplicationRole(new AuthApplicationRole(userInfo.getApplicationRole()));
    this.setFirstName(userInfo.getFirstName());
    this.setLastName(userInfo.getLastName());
    this.setHomeOrganization(userInfo.getHomeOrganization());
    this.setCreationWhen(userInfo.getCreationWhen());
    this.setCreationWho(userInfo.getCreationWho());
    this.setLastUpdateWhen(userInfo.getLastUpdateWhen());
    this.setLastUpdateWho(userInfo.getLastUpdateWho());
  }

  @Override
  public OffsetDateTime getCreationWhen() {
    return this.creationWhen;
  }

  public void setCreationWhen(OffsetDateTime creationWhen) {
    this.creationWhen = creationWhen;
  }

  @Override
  public OffsetDateTime getLastUpdateWhen() {
    return this.lastUpdateWhen;
  }

  public void setLastUpdateWhen(OffsetDateTime lastUpdateWhen) {
    this.lastUpdateWhen = lastUpdateWhen;
  }

  @Override
  public String getCreationWho() {
    return this.creationWho;
  }

  public void setCreationWho(String creationWho) {
    this.creationWho = creationWho;
  }

  @Override
  public String getLastUpdateWho() {
    return this.lastUpdateWho;
  }

  public void setLastUpdateWho(String lastUpdateWho) {
    this.lastUpdateWho = lastUpdateWho;
  }

  public AuthLoginInfo getFirstLogin() {
    return this.firstLogin;
  }

  public void setFirstLogin(AuthLoginInfo firstLogin) {
    this.firstLogin = firstLogin;
  }

  public LoginInfo getLastLogin() {
    return this.lastLogin;
  }

  public void setLastLogin(AuthLoginInfo lastLogin) {
    this.lastLogin = lastLogin;
  }

  @Override
  public String getResId() {
    return this.resId;
  }

  public void setResId(String resId) {
    this.resId = resId;
  }

  @Override
  public String getExternalUid() {
    return this.externalUid;
  }

  public void setExternalUid(String externalUid) {
    this.externalUid = externalUid;
  }

  @Override
  public ApplicationRole getApplicationRole() {
    return this.applicationRole;
  }

  public void setApplicationRole(AuthApplicationRole applicationRole) {
    this.applicationRole = applicationRole;
  }

  public void setDisabled(Boolean disabled) {
    this.disabled = disabled;
  }

  @Override
  public String getEmail() {
    return this.email;
  }

  public void setEmail(String email) {
    this.email = email;
  }

  @Override
  public String getFirstName() {
    return this.firstName;
  }

  public void setFirstName(String firstName) {
    this.firstName = firstName;
  }

  @Override
  public String getFullName() {
    return this.getLastName() + ", " + this.getFirstName();
  }

  @Override
  public String getHomeOrganization() {
    return this.homeOrganization;
  }

  public void setHomeOrganization(String homeOrganization) {
    this.homeOrganization = homeOrganization;
  }

  @Override
  public String getLastName() {
    return this.lastName;
  }

  public void setLastName(String lastName) {
    this.lastName = lastName;
  }

  @Override
  public boolean isEnabled() {
    return !this.disabled;
  }

}
