package ch.unige.solidify.util;

import org.springframework.boot.web.client.RestTemplateBuilder;
import org.springframework.context.annotation.Profile;
import org.springframework.stereotype.Component;

import ch.unige.solidify.service.HttpRequestInfoProvider;

/**
 * This RestClientTool use the token from the incoming request without fallback.
 */
@Profile({"client-backend", "test"})
@Component
public class PropagateRestClientTool extends AbstractRestClientTool {

  private final HttpRequestInfoProvider httpRequestInfoProvider;

  public PropagateRestClientTool(HttpRequestInfoProvider httpRequestInfoProvider) {
    this.httpRequestInfoProvider = httpRequestInfoProvider;
  }

  @Override
  protected RestTemplateBuilder addToken(RestTemplateBuilder restTemplateBuilder) {
    return this.addTokenFromRequest(restTemplateBuilder, this.httpRequestInfoProvider);
  }

}
