package ch.unige.solidify.exception;

import java.time.LocalDateTime;

import org.springframework.http.HttpStatus;

import ch.unige.solidify.repository.SolidifyError;

public class SolidifyHttpErrorException extends SolidifyRuntimeException {
  private static final long serialVersionUID = -1095213850780070956L;
  private final SolidifyError solidifyError = new SolidifyError();

  public SolidifyHttpErrorException(HttpStatus httpStatus, String message) {
    super(message);
    this.solidifyError.setError(httpStatus.toString());
    this.solidifyError.setMessage(message);
    this.solidifyError.setStatus(httpStatus);
    this.solidifyError.setTimeStamp(LocalDateTime.now().toString());
  }

  public SolidifyError getSolidifyError() {
    return this.solidifyError;
  }
}
