package ch.unige.solidify.service;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Component;

@Component
@PropertySource("classpath:git.properties")
@ConfigurationProperties(prefix = "git")
public class GitInfoProperties {

  private String branch;
  private Build build = new Build();
  private Commit commit = new Commit();
  private Remote remote = new Remote();

  public static class Build {
    private String host;
    private String time;
    private String version;
    private User user = new User();

    public static class User {
      private String email;
      private String name;

      public String getEmail() {
        return email;
      }

      public void setEmail(String email) {
        this.email = email;
      }

      public String getName() {
        return name;
      }

      public void setName(String name) {
        this.name = name;
      }
    }

    public String getHost() {
      return host;
    }

    public void setHost(String host) {
      this.host = host;
    }

    public String getTime() {
      return time;
    }

    public void setTime(String time) {
      this.time = time;
    }

    public String getVersion() {
      return version;
    }

    public void setVersion(String version) {
      this.version = version;
    }

    public User getUser() {
      return user;
    }

    public void setUser(User user) {
      this.user = user;
    }
  }
  public static class Commit {
    private String time;
    private Id id = new Id();
    private Message message = new Message();
    private User user = new User();

    public static class Id {
      private String abbrev;

      public String getAbbrev() {
        return abbrev;
      }

      public void setAbbrev(String abbrev) {
        this.abbrev = abbrev;
      }
    }
    public static class Message {
      private String full;

      public String getFull() {
        return full;
      }

      public void setFull(String full) {
        this.full = full;
      }
    }
    public static class User {
      private String email;
      private String name;

      public String getEmail() {
        return email;
      }

      public void setEmail(String email) {
        this.email = email;
      }

      public String getName() {
        return name;
      }

      public void setName(String name) {
        this.name = name;
      }
    }

    public String getTime() {
      return time;
    }

    public void setTime(String time) {
      this.time = time;
    }

    public Id getId() {
      return id;
    }

    public void setId(Id id) {
      this.id = id;
    }

    public Message getMessage() {
      return message;
    }

    public void setMessage(Message message) {
      this.message = message;
    }

    public User getUser() {
      return user;
    }

    public void setUser(User user) {
      this.user = user;
    }
  }
  public static class Remote {
    private Origin origin = new Origin();
    public static class Origin {
      private String url;

      public String getUrl() {
        return url;
      }

      public void setUrl(String url) {
        this.url = url;
      }
    }

    public Origin getOrigin() {
      return origin;
    }

    public void setOrigin(Origin origin) {
      this.origin = origin;
    }
  }

  public String getBranch() {
    return branch;
  }

  public void setBranch(String branch) {
    this.branch = branch;
  }

  public Build getBuild() {
    return build;
  }

  public void setBuild(Build build) {
    this.build = build;
  }

  public Commit getCommit() {
    return commit;
  }

  public void setCommit(Commit commit) {
    this.commit = commit;
  }

  public Remote getRemote() {
    return remote;
  }

  public void setRemote(Remote remote) {
    this.remote = remote;
  }
}
