package ch.unige.solidify.test.controller;

import static org.junit.jupiter.api.Assertions.assertNull;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.security.authentication.AnonymousAuthenticationToken;
import org.springframework.security.core.authority.AuthorityUtils;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.test.context.junit.jupiter.SpringExtension;

import ch.unige.solidify.model.User;
import ch.unige.solidify.service.SsoUserService;
import ch.unige.solidify.test.controller.config.MockApplication;

@ExtendWith(SpringExtension.class)
@AutoConfigureMockMvc
@SpringBootTest(classes = MockApplication.class)
class SsoUserServiceTest {
  @Autowired
  private SsoUserService ssoUserService;

  private final String userName = "UserTest";

  @BeforeEach
  public void setUp() {
    SecurityContextHolder.getContext().setAuthentication(new AnonymousAuthenticationToken("KeyTest",
            this.userName, AuthorityUtils.createAuthorityList("ROLE_ONE", "ROLE_TWO")));
  }

  @Test
  void testNonSsoUser() {
    final User user = this.ssoUserService.current();
    assertNull(user);
  }
}
