package ch.unige.solidify.model;

import org.springframework.data.domain.Sort;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import ch.unige.solidify.rest.RestCollectionPage;

public class SearchRequest {

  private String conditions;
  private String query;
  private int size = RestCollectionPage.DEFAULT_SIZE_PAGE;
  private int page = 0;

  @JsonSerialize(using = SortJsonSerializer.class)
  @JsonDeserialize(using = SortJsonDeserializer.class)
  private Sort sort;

  public SearchRequest() {

  }

  public SearchRequest(String conditions, String query, int size, int page, Sort sort) {
    this.conditions = conditions;
    this.query = query;
    this.size = size;
    this.page = page;
    if (sort != null && !sort.isEmpty() && sort.isSorted()) {
      this.sort = sort;
    }
  }

  public String getConditions() {
    return this.conditions;
  }

  public void setConditions(String conditions) {
    this.conditions = conditions;
  }

  public String getQuery() {
    return this.query;
  }

  public void setQuery(String query) {
    this.query = query;
  }

  public int getSize() {
    return this.size;
  }

  public void setSize(int size) {
    this.size = size;
  }

  public int getPage() {
    return this.page;
  }

  public void setPage(int page) {
    this.page = page;
  }

  public Sort getSort() {
    return sort;
  }

  public void setSort(Sort sort) {
    this.sort = sort;
  }

  @Override
  public String toString() {
    return "SearchRequest{" +
            "conditions='" + conditions + '\'' +
            ", query='" + query + '\'' +
            ", size=" + size +
            ", page=" + page +
            ", sort=" + sort.toString() +
            '}';
  }
}
