package ch.unige.solidify.model;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.databind.SerializerProvider;
import org.springframework.data.domain.Sort;

import java.io.IOException;

public class SortJsonSerializer extends JsonSerializer<Sort> {

  @Override
  public void serialize(Sort orders, JsonGenerator jsonGenerator, SerializerProvider serializerProvider) throws IOException {
    jsonGenerator.writeStartArray();
    orders.iterator().forEachRemaining(o -> {
      try {
        jsonGenerator.writeObject(o);
      } catch (IOException e) {
        e.printStackTrace();
      }
    });
    jsonGenerator.writeEndArray();
  }

  @Override
  public Class<Sort> handledType() {
    return Sort.class;
  }

}