package ch.unige.solidify.model.index;

import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;

import ch.unige.solidify.rest.NoSqlResource;
import ch.unige.solidify.util.JSONTool;

@JsonDeserialize(using = IndexSettingsDeserializer.class)
public class IndexSettings extends NoSqlResource {

  private Map<String, Object> settings = new HashMap<>();

  @Override
  public boolean equals(final Object other) {
    if (!(other instanceof IndexSettings)) {
      return false;
    }
    final IndexSettings castOther = (IndexSettings) other;
    return Objects.equals(this.settings, castOther.settings);
  }

  public Map<String, Object> getSettings() {
    return this.settings;
  }

  @Override
  public int hashCode() {
    return Objects.hash(this.settings);
  }

  public void setSettings(Map<String, Object> settings) {
    this.settings = settings;
  }

  public void setSettings(String settings) {
    this.settings = JSONTool.convertJson2Map(settings);
  }

  @Override
  public boolean update(NoSqlResource item) {
    return false;
  }
}
