package ch.unige.solidify.model.index;

import java.io.IOException;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.JsonDeserializer;
import com.fasterxml.jackson.databind.JsonNode;

import ch.unige.solidify.SolidifyConstants;

public class IndexSettingsDeserializer extends JsonDeserializer<IndexSettings> {

  @Override
  public IndexSettings deserialize(JsonParser jp, DeserializationContext ctxt) throws IOException {
    final JsonNode node = jp.getCodec().readTree(jp);
    final IndexSettings ai = new IndexSettings();
    ai.setResId(node.get(SolidifyConstants.DB_RES_ID).asText());
    if (node.has("settings")) {
      ai.setSettings(node.findValue("settings").toString());
    }
    return ai;
  }
}