package ch.unige.solidify.controller.index;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.data.domain.Pageable;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.IndexUrlPath;
import ch.unige.solidify.controller.IndexController;
import ch.unige.solidify.controller.ResourceController;
import ch.unige.solidify.model.index.IndexFieldAlias;
import ch.unige.solidify.rest.RestCollection;
import ch.unige.solidify.security.AdminPermissions;

@AdminPermissions
@RestController
@ConditionalOnBean(IndexController.class)
@RequestMapping(IndexUrlPath.INDEX_INDEX_FIELD_ALIAS)
public class IndexFieldAliasController extends ResourceController<IndexFieldAlias> {

  @Override
  public HttpEntity<IndexFieldAlias> create(@RequestBody IndexFieldAlias indexFieldAlias) {
    return super.create(indexFieldAlias);
  }

  @Override
  public HttpEntity<IndexFieldAlias> get(@PathVariable String id) {
    return super.get(id);
  }

  @Override
  public HttpEntity<RestCollection<IndexFieldAlias>> list(@ModelAttribute IndexFieldAlias search, Pageable pageable) {
    return super.list(search, pageable);
  }

  @Override
  public HttpEntity<IndexFieldAlias> update(@PathVariable String id, @RequestBody IndexFieldAlias t2) {
    return super.update(id, t2);
  }

  @Override
  public HttpStatus delete(@PathVariable String id) {
    return super.delete(id);
  }

  @Override
  public HttpStatus deleteList(@RequestBody String[] ids) {
    return super.deleteList(ids);
  }

}
