package ch.unige.solidify.controller.index;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.IndexConstants;
import ch.unige.solidify.IndexUrlPath;
import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.controller.AssociationIndexReadOnlyController;
import ch.unige.solidify.controller.IndexController;
import ch.unige.solidify.model.index.IndexMetadata;
import ch.unige.solidify.model.index.IndexSettings;
import ch.unige.solidify.security.TrustedUserPermissions;
import ch.unige.solidify.service.CompositeNoSqlResourceService;
import ch.unige.solidify.service.IndexResourceService;

@TrustedUserPermissions
@RestController
@ConditionalOnBean(IndexController.class)
@RequestMapping(IndexUrlPath.INDEX_INDEX + SolidifyConstants.URL_PARENT_ID + IndexConstants.METADATA)
public class IndexMetadataController extends AssociationIndexReadOnlyController<IndexSettings, IndexMetadata> {

  public IndexMetadataController(
          CompositeNoSqlResourceService<IndexSettings> noSqlResourceService,
          IndexResourceService<IndexSettings, IndexMetadata> indexSubResourceService) {
    super(noSqlResourceService, indexSubResourceService);
  }

  @Override
  protected String getIndex() {
    return null;
  }

  @Override
  protected Class<IndexSettings> getMainResourceClass() {
    return IndexSettings.class;
  }

  @Override
  protected Class<IndexMetadata> getSubResourceClass() {
    return IndexMetadata.class;
  }

}
