package ch.unige.solidify.controller.index;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.data.domain.Pageable;
import org.springframework.http.HttpEntity;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.IndexUrlPath;
import ch.unige.solidify.controller.IndexController;
import ch.unige.solidify.controller.NoSqlResourceReadOnlyController;
import ch.unige.solidify.index.settings.IndexingSettingsService;
import ch.unige.solidify.model.index.IndexSettings;
import ch.unige.solidify.rest.RestCollection;
import ch.unige.solidify.security.TrustedUserPermissions;

@TrustedUserPermissions
@RestController
@ConditionalOnBean(IndexController.class)
@RequestMapping(IndexUrlPath.INDEX_INDEX)
public class IndexesController extends NoSqlResourceReadOnlyController<IndexSettings> {

  public IndexesController(IndexingSettingsService<IndexSettings> noSqlResourceService) {
    super(noSqlResourceService);
  }

  @Override
  public HttpEntity<IndexSettings> get(@PathVariable String id) {
    return super.get(id);
  }

  @Override
  public HttpEntity<RestCollection<IndexSettings>> list(@ModelAttribute IndexSettings search, Pageable pageable) {
    return super.list(search, pageable);
  }

}
