package ch.unige.solidify.index.indexing;

import ch.unige.solidify.IndexProperties;
import ch.unige.solidify.exception.SolidifyRuntimeException;
import ch.unige.solidify.model.index.IndexMetadata;
import ch.unige.solidify.service.IndexResourceService;

public abstract class IndexingService<T extends IndexMetadata> extends IndexResourceService<String, T> {

  private String indexPrefix;

  public IndexingService(IndexProperties indexProperties) {
    this.indexPrefix = indexProperties.getIndexPrefix();
  }

  protected abstract T getMetadataObject();

  protected void checkIndex(String indexName) {
    if (!indexName.startsWith(this.indexPrefix)) {
      throw new SolidifyRuntimeException("Invalid index name '" + indexName + "' must start with '" + this.indexPrefix + "'");
    }
  }

}
