package ch.unige.solidify.index.indexing.elasticsearch;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.context.annotation.Profile;
import org.springframework.stereotype.Service;

import ch.unige.solidify.IndexProperties;
import ch.unige.solidify.controller.IndexController;
import ch.unige.solidify.index.ElasticsearchClientProvider;
import ch.unige.solidify.model.index.IndexMetadata;

@Profile("index-elasticsearch")
@Service
@ConditionalOnBean(IndexController.class)
public class IndexMetadataService extends ElasticsearchService<IndexMetadata> {
  public IndexMetadataService(
          IndexProperties indexProperties,
          ElasticsearchClientProvider elasticsearchClientProvider) {
    super(indexProperties, elasticsearchClientProvider);
  }

  @Override
  protected IndexMetadata getMetadataObject() {
    return new IndexMetadata();
  }

  @Override
  public String getIndexName(String indexName) {
    return indexName;
  }

}
