package ch.unige.solidify.index.indexing.inmemory;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.context.annotation.Profile;
import org.springframework.stereotype.Service;

import ch.unige.solidify.IndexDefinitionList;
import ch.unige.solidify.IndexProperties;
import ch.unige.solidify.controller.IndexController;
import ch.unige.solidify.index.settings.IndexingSettingsService;
import ch.unige.solidify.model.index.IndexMetadata;
import ch.unige.solidify.model.index.IndexSettings;

@Profile("index-inmemory")
@Service
@ConditionalOnBean(IndexController.class)
public class InMemoryIndexMetadataService extends InMemoryService<IndexMetadata> {
  public InMemoryIndexMetadataService(
          IndexProperties indexProperties,
          IndexingSettingsService<IndexSettings> settingsService,
          IndexDefinitionList indexList,
          IndexData indexData) {
    super(indexProperties, settingsService, indexList, indexData);
  }

  @Override
  protected IndexMetadata getMetadataObject() {
    return new IndexMetadata();
  }

  @Override
  public String getIndexName(String indexName) {
    return indexName;
  }

}
