package ch.unige.solidify.repository;

import java.util.List;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import ch.unige.solidify.controller.IndexController;
import ch.unige.solidify.model.dto.FacetSortDTO;
import ch.unige.solidify.model.index.IndexFieldAlias;

@Repository
@ConditionalOnBean(IndexController.class)
public interface IndexFieldAliasRepository extends SolidifyRepository<IndexFieldAlias> {

  IndexFieldAlias findByIndexNameAndAlias(String index, String alias);

  @Query("SELECT NEW ch.unige.solidify.model.dto.FacetSortDTO(ifa.resId, ifa.facetOrder) FROM IndexFieldAlias ifa "
          + "WHERE ifa.indexName = :indexName AND ifa.facetOrder IS NOT NULL "
          + "AND ifa.facetOrder = (SELECT MAX(ifa2.facetOrder) FROM IndexFieldAlias ifa2 WHERE ifa2.indexName = :indexName)")
  List<FacetSortDTO> findByMaxFacetOrderAndIndexName(String indexName);

}
