package ch.unige.solidify.model;

import javax.persistence.Embeddable;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.MappedSuperclass;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.rest.EmbeddableEntity;

@Embeddable
@MappedSuperclass
public abstract class Label<T> implements EmbeddableEntity<T> {

  @NotNull
  @Size(max = SolidifyConstants.DB_LONG_STRING_LENGTH)
  private String text;

  @NotNull
  @ManyToOne
  @JoinColumn(name = SolidifyConstants.DB_LANGUAGE_ID, referencedColumnName = SolidifyConstants.DB_RES_ID)
  private Language language;

  public String getText() {
    return this.text;
  }

  public Language getLanguage() {
    return this.language;
  }

  public void setText(String text) {
    this.text = text;
  }

  public void setLanguage(Language language) {
    this.language = language;
  }

  @Override
  public void update(T t) {
    // do nothing
  }
}
