package ch.unige.solidify.model;

import java.util.Objects;

import javax.persistence.Column;
import javax.persistence.Entity;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.rest.ResourceNormalized;
import ch.unige.solidify.util.ReflectionTool;

/**
 * Language representation names based in ISO 639-1 (2002)
 */
@Entity
public class Language extends ResourceNormalized {

  @Column(unique = true, nullable = false)
  private String code;

  @Override
  public boolean equals(final Object other) {
    if (this == other) {
      return true;
    }
    if (!(other instanceof Language)) {
      return false;
    }
    final Language castOther = (Language) other;
    return Objects.equals(this.getCode(), castOther.getCode());
  }

  public String getCode() {
    return this.code;
  }

  @Override
  public int hashCode() {
    return Objects.hash(this.getCode());
  }

  @Override
  public void init() {
    // Do nothing
  }

  @Override
  public String managedBy() {
    return SolidifyConstants.ADMIN_MODULE;
  }

  public void setCode(String code) {
    this.setProperty(ReflectionTool.getCurrentSetterVariableName(), code);
  }
}
