package ch.unige.solidify.model;

import java.io.Serializable;
import java.time.OffsetDateTime;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

import org.springframework.data.annotation.LastModifiedDate;

import com.fasterxml.jackson.annotation.JsonFormat;

import ch.unige.solidify.util.StringTool;

@Embeddable
public class LastModifiedChangeInfo implements ChangeInfo, Serializable {

  private static final long serialVersionUID = -3801924551562715912L;

  @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = StringTool.DATE_TIME_FORMAT)
  @LastModifiedDate
  private OffsetDateTime when;

  private String who;

  @Transient
  private String name;

  public OffsetDateTime getWhen() {
    return this.when;
  }

  public String getWho() {
    return this.who;
  }

  public void setWhen(OffsetDateTime when) {
    this.when = when;
  }

  public void setWho(String who) {
    this.who = who;
  }

  public String getFullName() {
    if (StringTool.isNullOrEmpty(this.name)) {
      return this.getWho();
    } else {
      return this.name;
    }
  }

  public void setFullName(String fullName) {
    this.name = fullName;
  }

  @Override
  public String toString() {
    return "LastModifiedChangeInfo{" +
            "when=" + this.when +
            ", who='" + this.who + '\'' +
            '}';
  }

}
