package ch.unige.solidify.rest;

import java.util.Objects;

import org.springframework.hateoas.RepresentationModel;
import org.springframework.hateoas.server.mvc.WebMvcLinkBuilder;

public abstract class NoSqlResource extends RepresentationModel<NoSqlResource> {
  private String resId;

  public void addLinks(WebMvcLinkBuilder linkBuilder) {
    this.add(linkBuilder.slash(this.getResId()).withSelfRel());
    this.add(linkBuilder.withRel(ActionName.LIST));
    this.add((Tool.parentLink(linkBuilder.toUriComponentsBuilder())).withRel(ActionName.MODULE));
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }
    if (!(obj instanceof NoSqlResource)) {
      return false;
    }
    if (!super.equals(obj)) {
      return false;
    }
    final NoSqlResource that = (NoSqlResource) obj;
    return Objects.equals(this.resId, that.resId);
  }

  public String getResId() {
    return this.resId;
  }

  @Override
  public int hashCode() {
    return Objects.hash(super.hashCode(), this.resId);
  }

  public void setResId(String resId) {
    this.resId = resId;
  }

  public abstract boolean update(NoSqlResource item);
}