package ch.unige.solidify.rest;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.domain.Pageable;

public interface ResourceClient<T extends Resource> {

  RestCollection<T> findAll(Pageable pageable);

  T findOne(String resId);

  @Cacheable(CacheNames.RESOURCES)
  default T findOneWithCache(String resId) {
    return this.findOne(resId);
  }

}
