package ch.unige.solidify.rest;

import javax.persistence.AttributeOverride;
import javax.persistence.Column;
import javax.persistence.Embedded;
import javax.persistence.EntityListeners;
import javax.persistence.MappedSuperclass;
import javax.validation.Valid;

import ch.unige.solidify.listener.CacheListener;
import ch.unige.solidify.model.ChangeInfo;
import ch.unige.solidify.model.RegularChangeInfo;

@MappedSuperclass
@EntityListeners({ CacheListener.class })
public abstract class ResourceLegacy extends ResourceDiverse {

  @AttributeOverride(name = "when", column = @Column(name = "d_cre"))
  @AttributeOverride(name = "who", column = @Column(name = "id_cre"))
  @Embedded
  @Valid
  protected RegularChangeInfo creation = new RegularChangeInfo();

  @AttributeOverride(name = "when", column = @Column(name = "d_maj"))
  @AttributeOverride(name = "who", column = @Column(name = "id_maj"))
  @Embedded
  @Valid
  protected RegularChangeInfo lastUpdate = new RegularChangeInfo();

  @Override
  public ChangeInfo getCreation() {
    return this.creation;
  }

  @Override
  public ChangeInfo getLastUpdate() {
    return this.lastUpdate;
  }

}
