package ch.unige.solidify.specification;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import org.springframework.data.jpa.domain.Specification;

import ch.unige.solidify.model.SolidifyApplicationRole;

public class ApplicationRoleSpecification implements Specification<SolidifyApplicationRole> {
  private static final long serialVersionUID = -1235772724215350229L;

  private final transient SolidifyApplicationRole criteria;

  public ApplicationRoleSpecification(SolidifyApplicationRole criteria) {
    this.criteria = criteria;
  }

  @Override
  public Predicate toPredicate(Root<SolidifyApplicationRole> root, CriteriaQuery<?> query,
          CriteriaBuilder builder) {

    final List<Predicate> listPredicate = new ArrayList<>();

    if (this.criteria.getName() != null) {
      listPredicate.add(builder.like(root.get("name"), "%" + this.criteria.getName() + "%"));
    }

    return builder.and(listPredicate.toArray(new Predicate[listPredicate.size()]));
  }

}
