package ch.unige.solidify.test.util;

import static org.junit.jupiter.api.Assertions.assertEquals;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.test.context.junit.jupiter.SpringExtension;

import ch.unige.solidify.rest.ResourceNormalized;
import ch.unige.solidify.util.ReflectionTool;

@ExtendWith(SpringExtension.class)
class ReflectionToolTest {
  private static class ResourceTest extends ResourceNormalized {

    @Override
    public void init() {
    }

    @Override
    public String managedBy() {
      return null;
    }

    public void setMyField() {
      assertEquals("myField", ReflectionTool.getCurrentSetterVariableName());
    }
  }

  @Test
  void getCurrentSetterVariableNameTest() {
    final ResourceTest resourceTest = new ResourceTest();
    resourceTest.setMyField();
  }

}
