package ch.unige.solidify.util;

import org.springframework.hateoas.Link;
import org.springframework.web.util.UriComponentsBuilder;

import ch.unige.solidify.OAIConstants;

public class OAITool {
  public static Link oaiLink(UriComponentsBuilder ucb, String verb) {
    ucb.queryParam(OAIConstants.OAI_VERB, verb);
    return Link.of(ucb.toUriString());
  }

  public static Link oaiLink(UriComponentsBuilder ucb, String verb, String metadataPrefix) {
    ucb.queryParam(OAIConstants.OAI_VERB, verb);
    ucb.queryParam(OAIConstants.OAI_METADATAPREFIX, metadataPrefix);
    return Link.of(ucb.toUriString());
  }

}
