package ch.unige.solidify.controller;

import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.OAIConstants;
import ch.unige.solidify.OAIUrlPath;
import ch.unige.solidify.business.OAISetService;
import ch.unige.solidify.exception.SolidifyRuntimeException;

@RestController
@ConditionalOnProperty(prefix = "solidify.oai-pmh", name = "enable")
@RequestMapping(OAIUrlPath.OAI)
public class OAIController extends ModuleController {

  OAIController(OAISetService oaiSetService) {
    super(OAIConstants.OAI_MODULE);
    // Module initialization
    try {
      oaiSetService.initDefaultData();
    } catch (final Exception e) {
      throw new SolidifyRuntimeException(e.getMessage());
    }
  }

}
