package ch.unige.solidify.controller.oai;

import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.data.domain.Pageable;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import ch.unige.solidify.OAIUrlPath;
import ch.unige.solidify.controller.OAIController;
import ch.unige.solidify.controller.ResourceController;
import ch.unige.solidify.model.oai.OAISet;
import ch.unige.solidify.rest.RestCollection;
import ch.unige.solidify.security.AdminPermissions;

@RestController
@AdminPermissions
@ConditionalOnBean(OAIController.class)
@RequestMapping(OAIUrlPath.OAI_SET)
public class OAISetController extends ResourceController<OAISet> {

  @Override
  public HttpEntity<OAISet> create(@RequestBody OAISet oaiSet) {
    return super.create(oaiSet);
  }

  @Override
  public HttpEntity<OAISet> get(@PathVariable String id) {
    return super.get(id);
  }

  @Override
  public HttpEntity<RestCollection<OAISet>> list(@ModelAttribute OAISet search, Pageable pageable) {
    return super.list(search, pageable);
  }

  @Override
  public HttpEntity<OAISet> update(@PathVariable String id, @RequestBody OAISet oaiSet) {
    return super.update(id, oaiSet);
  }

  @Override
  public HttpStatus delete(@PathVariable String id) {
    return super.delete(id);
  }

  @Override
  public HttpStatus deleteList(@RequestBody String[] ids) {
    return super.deleteList(ids);
  }

}
