package ch.unige.solidify;

public class SolidifyConstants {

  private SolidifyConstants() {
    throw new IllegalStateException(TOOL_CLASS);
  }

  public static final String TOOL_CLASS = "Utility class";
  public static final String MANIFEST = "/META-INF/MANIFEST.MF";

  // Module
  public static final String ADMIN_MODULE = "admin";

  // Default buffer size
  public static final int BUFFER_SIZE = 4 * 1024 * 1024; // 4MB

  // Separators
  public static final String VALUE_SEP = "=";
  public static final String FIELD_SEP = ";";
  public static final String ID_SEP = "-";
  public static final String ID_CONCAT = "+";

  public static final String YES = "yes";

  // URL
  public static final String URL_SEP = "/";
  public static final String URL_PARENT_ID_FIELD = "parentid";
  public static final String URL_ID_FIELD = "id";
  public static final String URL_GRAND_CHILD_ID_FIELD = "grandChildId";
  public static final String URL_ID = URL_SEP + "{" + URL_ID_FIELD + "}";
  public static final String URL_ID_PLUS_SEP = URL_ID + URL_SEP;
  public static final String URL_PARENT_ID = URL_SEP + "{" + URL_PARENT_ID_FIELD + "}" + URL_SEP;
  public static final String URL_DASHBOARD = URL_SEP + "dashboard";
  public static final String URL_GRAND_CHILD_ID = URL_SEP + "{" + URL_GRAND_CHILD_ID_FIELD + "}";
  public static final String URL_ADMIN_MODULE = URL_SEP + "admin";
  public static final String ORCID = "orcid";
  public static final String URL_ORCID = URL_ADMIN_MODULE + URL_SEP + ORCID;
  public static final String URL_EXTERNAL_UID = URL_SEP + "{externalUid}";

  // Module
  public static final String RES_SRV = "resource-srv";

  // Prefix
  public static final String BASE64_PREFIX = "{base64}";

  // Security
  public static final String NO_CREDENTIAL = "Anonymous";

  // Extension
  public static final String XML_MIME_TYPE = "application/xml";
  public static final String ZIP_MIME_TYPE = "application/zip";
  public static final String JSON_MIME_TYPE = "application/json";
  public static final String OCTET_STREAM_MIME_TYPE = "application/octet-stream";
  public static final String ZIP_EXT = ".zip";
  public static final String XML_EXT = ".xml";
  public static final String JSON_EXT = ".json";
  public static final String XSD_EXT = ".xsd";
  public static final String XSL_EXT = ".xsl";
  public static final String XML_OUTPUT_EXT = "-out.xml";
  public static final String HTML_EXT = ".html";

  // Message processor
  public static final String MESSAGE_PROCESSOR_ROLE = "MESSAGE_PROCESSOR";

  // XML
  public static final String SCHEMA_HOME = "schemas";

  // Database constants
  public static final int DB_SHORT_STRING_LENGTH = 30;
  public static final int DB_MEDIUM_STRING_LENGTH = 100;
  public static final int DB_DEFAULT_STRING_LENGTH = 255;
  public static final int DB_LONG_STRING_LENGTH = 1024;
  public static final int DB_LARGE_STRING_LENGTH = 4096;
  public static final int DB_DATE_LENGTH = 3;

  // Database column name
  public static final String DB_RES_ID = "resId";
  public static final String DB_LANGUAGE_ID = "languageId";

  // Test data
  public static final String TEST_RES_ID = "test";

}
