package ch.unige.solidify.util;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

public class XMLError implements ErrorHandler {

  private static final Logger log = LoggerFactory.getLogger(XMLError.class);

  private final boolean msg;
  private final boolean x7;

  public XMLError() {
    this.msg = false;
    this.x7 = true;
  }

  public XMLError(boolean m, boolean e) {
    this.msg = m;
    this.x7 = e;
  }

  @Override
  public void error(SAXParseException e) throws SAXException {
    if (this.msg) {
      log.error(e.getMessage());
    }
    if (this.x7) {
      throw e;
    }
  }

  @Override
  public void fatalError(SAXParseException e) throws SAXException {
    if (this.msg) {
      log.error(e.getMessage());
    }
    if (this.x7) {
      throw e;
    }
  }

  @Override
  public void warning(SAXParseException e) throws SAXException {
    if (this.msg) {
      log.warn(e.getMessage());
    }
    if (this.x7) {
      throw e;
    }
  }
}
